Skip to main content
`Ctrl`+`K`

# MatGetDiagonal

Gets the diagonal of a matrix as a `Vec`

## Synopsis

    #include "petscmat.h"
    PetscErrorCode MatGetDiagonal(Mat mat, Vec v)

Logically Collective

## Input Parameter

- mat - the matrix

## Output Parameter

- v - the diagonal of the matrix

## Note

If `mat` has local sizes `n` x `m`, this routine fills the first `ndiag = min(n, m)` entries of `v` with the diagonal values. Thus `v` must have local size of at least `ndiag`. If `v` is larger than `ndiag`, the values of the remaining entries are unspecified.

Currently only correct in parallel for square matrices.

## See Also

Matrices, `Mat`, `Vec`, `MatGetRow()`, `MatCreateSubMatrices()`, `MatCreateSubMatrix()`, `MatGetRowMaxAbs()`

## Level

intermediate

## Location

src/mat/interface/matrix.c

## Examples

src/ksp/pc/tutorials/ex2.c
src/ksp/ksp/tutorials/ex52.c
src/ksp/ksp/tutorials/ex15.c
src/ksp/pc/tutorials/ex1.c
src/ksp/ksp/tutorials/ex15f.F90
src/ksp/ksp/tutorials/ex21.c
src/snes/tutorials/ex70.c

## Implementations

MatGetDiagonal_MPIAIJ() in src/mat/impls/aij/mpi/mpiaij.c
MatGetDiagonal_STRUMPACK() in src/mat/impls/aij/mpi/strumpack/strumpack.c
MatGetDiagonal_SeqAIJ() in src/mat/impls/aij/seq/aij.c
MatGetDiagonal_SeqAIJKokkos() in src/mat/impls/aij/seq/kokkos/aijkok.kokkos.cxx
MatGetDiagonal_MPIBAIJ() in src/mat/impls/baij/mpi/mpibaij.c
MatGetDiagonal_SeqBAIJ() in src/mat/impls/baij/seq/baij2.c
MatGetDiagonal_ConstantDiagonal() in src/mat/impls/cdiagonal/cdiagonal.c
MatGetDiagonal_Composite() in src/mat/impls/composite/mcomposite.c
MatGetDiagonal_MPIDense() in src/mat/impls/dense/mpi/mpidense.c
MatGetDiagonal_SeqDense() in src/mat/impls/dense/seq/dense.c
MatGetDiagonal_Diagonal() in src/mat/impls/diagonal/diagonal.c
MatGetDiagonal_Elemental() in src/mat/impls/elemental/matelem.cxx
MatGetDiagonal_Htool() in src/mat/impls/htool/htool.cxx
MatGetDiagonal_HYPRE() in src/mat/impls/hypre/mhypre.c
MatGetDiagonal_IS() in src/mat/impls/is/matis.c
MatGetDiagonal_MFFD() in src/mat/impls/mffd/mffd.c
MatGetDiagonal_Nest() in src/mat/impls/nest/matnest.c
MatGetDiagonal_Normal() in src/mat/impls/normal/normm.c
MatGetDiagonal_NormalHermitian() in src/mat/impls/normal/normmh.c
MatGetDiagonal_MPISBAIJ() in src/mat/impls/sbaij/mpi/mpisbaij.c
MatGetDiagonal_SeqSBAIJ() in src/mat/impls/sbaij/seq/sbaij2.c
MatGetDiagonal_ScaLAPACK() in src/mat/impls/scalapack/matscalapack.c
MatGetDiagonal_MPISELL() in src/mat/impls/sell/mpi/mpisell.c
MatGetDiagonal_SeqSELL() in src/mat/impls/sell/seq/sell.c
MatGetDiagonal_Shell() in src/mat/impls/shell/shell.c
MatGetDiagonal_CF() in src/mat/impls/shell/shellcnv.c
MatGetDiagonal_SubMatrix() in src/mat/impls/submat/submat.c
MatGetDiagonal_HT() in src/mat/impls/transpose/htransm.c
MatGetDiagonal_Transpose() in src/mat/impls/transpose/transm.c

Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages